Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 1047)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1053)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! +qr, nr, qc and cross sections
 !
 ! Former revisions:
@@ -290,4 +290,12 @@
                 two_d = .TRUE.
                 level_z(nzb+1) = zu(nzb+1)
+
+             CASE ( 'nr_xy', 'nr_xz', 'nr_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => nr
+                ELSE
+                   to_be_resorted => nr_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
 
              CASE ( 'p_xy', 'p_xz', 'p_yz' )
@@ -376,22 +384,63 @@
 
              CASE ( 'prr*_xy' )        ! 2d-array
-                IF ( av == 0 )  THEN
-                   CALL exchange_horiz_2d( precipitation_rate )
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  precipitation_rate(j,i)
-                      ENDDO
-                   ENDDO
-                ELSE
-                   CALL exchange_horiz_2d( precipitation_rate_av )
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  precipitation_rate_av(j,i)
-                      ENDDO
-                   ENDDO
+                IF ( icloud_scheme == 1 )  THEN
+                   IF ( av == 0 )  THEN
+                      CALL exchange_horiz_2d( precipitation_rate )
+                      DO  i = nxlg, nxrg
+                         DO  j = nysg, nyng
+                            local_pf(i,j,nzb+1) =  precipitation_rate(j,i)
+                         ENDDO
+                      ENDDO
+                   ELSE
+                      CALL exchange_horiz_2d( precipitation_rate_av )
+                      DO  i = nxlg, nxrg
+                         DO  j = nysg, nyng
+                            local_pf(i,j,nzb+1) =  precipitation_rate_av(j,i)
+                         ENDDO
+                      ENDDO
+                   ENDIF
+                ELSE
+                   IF ( av == 0 )  THEN
+                      CALL exchange_horiz_2d( prr(nzb+1,:,:) )
+                      DO  i = nxlg, nxrg
+                         DO  j = nysg, nyng
+                            local_pf(i,j,nzb+1) = prr(nzb+1,j,i) * hyrho(nzb+1)
+                         ENDDO
+                      ENDDO
+                   ELSE
+                      CALL exchange_horiz_2d( prr_av(nzb+1,:,:) )
+                      DO  i = nxlg, nxrg
+                         DO  j = nysg, nyng
+                            local_pf(i,j,nzb+1) = prr_av(nzb+1,j,i) * hyrho(nzb+1)
+                         ENDDO
+                      ENDDO
+                   ENDIF
                 ENDIF
                 resorted = .TRUE.
                 two_d = .TRUE.
                 level_z(nzb+1) = zu(nzb+1)
+
+             CASE ( 'prr_xy', 'prr_xz', 'prr_yz' )
+                IF ( av == 0 )  THEN
+                   CALL exchange_horiz( prr, nbgp )
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nzt+1
+                            local_pf(i,j,k) = prr(k,j,i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ELSE
+                   CALL exchange_horiz( prr_av, nbgp )
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nzt+1
+                            local_pf(i,j,k) = prr_av(k,j,i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                resorted = .TRUE.
+                IF ( mode == 'xy' )  level_z = zu
 
              CASE ( 'pt_xy', 'pt_xz', 'pt_yz' )
@@ -424,9 +473,39 @@
                 IF ( mode == 'xy' )  level_z = zu
 
+             CASE ( 'qc_xy', 'qc_xz', 'qc_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => ql
+                ELSE
+                   to_be_resorted => ql_av
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
              CASE ( 'ql_xy', 'ql_xz', 'ql_yz' )
                 IF ( av == 0 )  THEN
-                   to_be_resorted => ql
-                ELSE
-                   to_be_resorted => ql_av
+                   IF ( icloud_scheme == 0 )  THEN
+                      DO  i = nxlg, nxrg
+                         DO  j = nysg, nyng
+                            DO  k = nzb, nz_do3d
+                               local_pf(i,j,k) = ql(k,j,i) + qr(k,j,i)
+                            ENDDO
+                         ENDDO
+                      ENDDO
+                      resorted = .TRUE.
+                   ELSE
+                      to_be_resorted => ql
+                   ENDIF
+                ELSE
+                   IF ( icloud_scheme == 0 )  THEN
+                      DO  i = nxlg, nxrg
+                         DO  j = nysg, nyng
+                            DO  k = nzb, nz_do3d
+                               local_pf(i,j,k) = ql_av(k,j,i) + qr_av(k,j,i)
+                            ENDDO
+                         ENDDO
+                      ENDDO
+                      resorted = .TRUE.
+                   ELSE
+                      to_be_resorted => ql_av
+                   ENDIF
                 ENDIF
                 IF ( mode == 'xy' )  level_z = zu
@@ -478,4 +557,12 @@
                    CALL exchange_horiz( ql_vp_av, nbgp )
                    to_be_resorted => ql_vp
+                ENDIF
+                IF ( mode == 'xy' )  level_z = zu
+
+             CASE ( 'qr_xy', 'qr_xz', 'qr_yz' )
+                IF ( av == 0 )  THEN
+                   to_be_resorted => qr
+                ELSE
+                   to_be_resorted => qr_av
                 ENDIF
                 IF ( mode == 'xy' )  level_z = zu
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1047)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1053)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! +nr, qr, prr, qc and averaged quantities
 !
 ! Former revisions:
@@ -207,4 +207,11 @@
              ENDIF
 
+          CASE ( 'nr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => nr
+             ELSE
+                to_be_resorted => nr_av
+             ENDIF
+
           CASE ( 'p' )
              IF ( av == 0 )  THEN
@@ -270,4 +277,26 @@
              ENDIF
 
+          CASE ( 'prr' )
+             IF ( av == 0 )  THEN
+                CALL exchange_horiz( prr, nbgp )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         local_pf(i,j,k) = prr(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ELSE
+                CALL exchange_horiz( prr_av, nbgp )
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      DO  k = nzb, nzt+1
+                         local_pf(i,j,k) = prr_av(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+             ENDIF
+             resorted = .TRUE.
+
           CASE ( 'pt' )
              IF ( av == 0 )  THEN
@@ -297,9 +326,38 @@
              ENDIF
 
+          CASE ( 'qc' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => ql
+             ELSE
+                to_be_resorted => ql_av
+             ENDIF
+
           CASE ( 'ql' )
              IF ( av == 0 )  THEN
-                to_be_resorted => ql
-             ELSE
-                to_be_resorted => ql_av
+                IF ( icloud_scheme == 0 )  THEN
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nz_do3d
+                            local_pf(i,j,k) = ql(k,j,i) + qr(k,j,i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                   resorted = .TRUE.
+                ELSE
+                   to_be_resorted => ql
+                ENDIF
+             ELSE
+                IF ( icloud_scheme == 0 )  THEN
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         DO  k = nzb, nz_do3d
+                            local_pf(i,j,k) = ql_av(k,j,i) + qr_av(k,j,i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                   resorted = .TRUE.
+                ELSE
+                   to_be_resorted => ql_av
+                ENDIF
              ENDIF
 
@@ -344,4 +402,11 @@
                 CALL exchange_horiz( ql_vp_av, nbgp )
                 to_be_resorted => ql_vp_av
+             ENDIF
+
+          CASE ( 'qr' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => qr
+             ELSE
+                to_be_resorted => qr_av
              ENDIF
 
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1047)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1053)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-!
+! necessary additions for two-moment cloud physics scheme:
+! +nr, qr, qc, prr
 !
 ! Former revisions:
@@ -748,14 +749,40 @@
 
 !
-!--             Buoyancy flux, water flux, humidity flux and liquid water
-!--             content
+!--             Buoyancy flux, water flux, humidity flux, liquid water
+!--             content, rain drop concentration and rain water content
                 IF ( humidity )  THEN
                    IF ( cloud_physics .OR. cloud_droplets )  THEN
-                      pts = 0.5 * ( vpt(k,j,i)   - hom(k,1,44,sr) + &
+                      pts = 0.5 * ( vpt(k,j,i)   - hom(k,1,44,sr) +        &
                                     vpt(k+1,j,i) - hom(k+1,1,44,sr) )
                       sums_l(k,46,tn) = sums_l(k,46,tn) + pts * w(k,j,i) * &
                                                           rmask(j,i,sr)
-                      sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) * &
-                                                          rmask(j,i,sr)
+                      IF ( .NOT. cloud_droplets )  THEN
+                         pts = 0.5 *                                          &
+                              ( ( q(k,j,i) - ql(k,j,i) ) -                    &
+                              hom(k,1,42,sr) +                                &
+                              ( q(k+1,j,i) - ql(k+1,j,i) ) -                  &
+                              hom(k+1,1,42,sr) )
+                         sums_l(k,52,tn) = sums_l(k,52,tn) + pts * w(k,j,i) * &
+                                                             rmask(j,i,sr)
+                         IF ( icloud_scheme == 0  )  THEN
+                            sums_l(k,54,tn) = sums_l(k,54,tn) + ( ql(k,j,i) + &
+                                                                qr(k,j,i) ) * &
+                                                                rmask(j,i,sr)
+                            sums_l(k,73,tn) = sums_l(k,73,tn) + nr(k,j,i) *   &
+                                                                rmask(j,i,sr)
+                            sums_l(k,74,tn) = sums_l(k,74,tn) + qr(k,j,i) *   &
+                                                                rmask(j,i,sr)
+                            sums_l(k,75,tn) = sums_l(k,75,tn) + ql(k,j,i) *   &
+                                                                rmask(j,i,sr)
+                            sums_l(k,76,tn) = sums_l(k,76,tn) + prr(k,j,i) *  &
+                                                                rmask(j,i,sr)
+                         ELSE
+                            sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) *   &
+                                                                rmask(j,i,sr)
+                         ENDIF
+                      ELSE
+                         sums_l(k,54,tn) = sums_l(k,54,tn) + ql(k,j,i) *      &
+                                                             rmask(j,i,sr)
+                      ENDIF
                    ELSE
                       IF( .NOT. ws_scheme_sca .OR. sr /= 0 )  THEN
@@ -765,5 +792,5 @@
                                                              rmask(j,i,sr)
                       ELSE IF ( ws_scheme_sca .AND. sr == 0 )  THEN
-                         sums_l(k,46,tn) = ( 1.0 + 0.61 * hom(k,1,41,sr) ) * &
+                         sums_l(k,46,tn) = ( 1.0 + 0.61 * hom(k,1,41,sr) ) *  &
                                              sums_l(k,17,tn) +      &
                                           0.61 * hom(k,1,4,sr) * sums_l(k,49,tn)
@@ -1105,4 +1132,8 @@
        hom(:,1,71,sr) = sums(:,71)     ! prho
        hom(:,1,72,sr) = hyp * 1E-4     ! hyp in dbar
+       hom(:,1,73,sr) = sums(:,73)     ! nr
+       hom(:,1,74,sr) = sums(:,74)     ! qr
+       hom(:,1,75,sr) = sums(:,75)     ! qc
+       hom(:,1,76,sr) = sums(:,76)     ! prr (precipitation rate)
 
        hom(:,1,pr_palm-1,sr) = sums(:,pr_palm-1)
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1047)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1053)
@@ -23,5 +23,8 @@
 ! Current revisions:
 ! ------------------
-!
+! allocation and initialisation of necessary data arrays for the two-moment 
+! cloud physics scheme the two new prognostic equations (nr, qr):
+! +dr, lambda_r, mu_r, sed_*, xr, *s, *sws, *swst, *, *_p, t*_m, *_1, *_2, *_3, 
+! +tend_*, prr
 !
 ! Former revisions:
@@ -353,4 +356,5 @@
 
           IF ( cloud_physics ) THEN
+
 !
 !--          Liquid water content
@@ -364,4 +368,51 @@
              ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg), &
                        precipitation_rate(nysg:nyng,nxlg:nxrg) )
+
+             IF ( icloud_scheme == 0 )  THEN
+!
+!--             1D-rain sedimentation fluxes and rain drop size distribution
+!--             properties 
+                ALLOCATE ( dr(nzb:nzt+1), lambda_r(nzb:nzt+1),  &
+                           mu_r(nzb:nzt+1), sed_q(nzb:nzt+1),   &
+                           sed_qr(nzb:nzt+1), sed_nr(nzb:nzt+1),& 
+                           xr(nzb:nzt+1) ) 
+!
+!--             2D-rain water content and rain drop concentration arrays
+                ALLOCATE ( qrs(nysg:nyng,nxlg:nxrg),   &
+                   qrsws(nysg:nyng,nxlg:nxrg),         &
+                   qrswst(nysg:nyng,nxlg:nxrg),        &
+                   nrs(nysg:nyng,nxlg:nxrg),           &
+                   nrsws(nysg:nyng,nxlg:nxrg),         &
+                   nrswst(nysg:nyng,nxlg:nxrg) )
+!
+!--             3D-rain water content, rain drop concentration arrays
+#if defined( __nopointer )
+                ALLOCATE( nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),         &
+                          nr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),         &
+                          qr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          tnr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),      &
+                          tqr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#else
+                ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),       &
+                          qr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+#endif
+!
+!--             3D-tendency arrays
+                ALLOCATE( tend_nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
+                          tend_pt(nzb:nzt+1,nysg:nyng,nxlg:nxrg),    &
+                          tend_q(nzb:nzt+1,nysg:nyng,nxlg:nxrg),     &
+                          tend_qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!
+!--             3d-precipitation rate
+                IF ( precipitation )  THEN
+                   ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ENDIF
+
+             ENDIF
           ENDIF
 
@@ -508,6 +559,14 @@
     IF ( humidity  .OR.  passive_scalar )  THEN
        q => q_1;  q_p => q_2;  tq_m => q_3
-       IF ( humidity )        vpt  => vpt_1
-       IF ( cloud_physics )   ql   => ql_1
+       IF ( humidity )  THEN
+          vpt  => vpt_1    
+          IF ( cloud_physics )  THEN
+             ql => ql_1
+             IF ( icloud_scheme == 0 )  THEN
+                qr => qr_1;  qr_p  => qr_2;  tqr_m  => qr_3
+                nr => nr_1;  nr_p  => nr_2;  tnr_m  => nr_3
+             ENDIF
+          ENDIF
+       ENDIF
        IF ( cloud_droplets )  THEN
           ql   => ql_1
@@ -564,4 +623,12 @@
                 ENDDO
              ENDDO
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qr(:,j,i) = qr_init
+                      nr(:,j,i) = nr_init
+                   ENDDO
+                ENDDO
+             ENDIF
           ENDIF
 
@@ -606,5 +673,11 @@
 !--       This could actually be computed more accurately in the 1D model.
 !--       Update when opportunity arises!
-          IF ( humidity  .OR.  passive_scalar )  qs = 0.0
+          IF ( humidity  .OR.  passive_scalar )  THEN
+             qs = 0.0
+             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+                qrs = 0.0
+                nrs = 0.0
+             ENDIF
+          ENDIF
 
 !
@@ -671,4 +744,12 @@
                 ENDDO
              ENDDO
+             IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qr(:,j,i) = qr_init
+                      nr(:,j,i) = nr_init
+                   ENDDO
+                ENDDO
+             ENDIF
           ENDIF
 
@@ -811,4 +892,12 @@
 !--       Determine the near-surface water flux
           IF ( humidity  .OR.  passive_scalar )  THEN
+             IF ( cloud_physics .AND. icloud_scheme )  THEN
+                IF ( constant_waterflux_qr )  THEN
+                   qrsws = surface_waterflux_qr
+                ENDIF
+                IF (constant_waterflux_nr )  THEN
+                   nrsws = surface_waterflux_nr
+                ENDIF
+             ENDIF
              IF ( constant_waterflux )  THEN
                 qsws   = surface_waterflux
@@ -842,5 +931,11 @@
              tswst = top_heatflux
 
-             IF ( humidity  .OR.  passive_scalar )  qswst = 0.0
+             IF ( humidity  .OR.  passive_scalar )  THEN
+                qswst = 0.0
+                IF ( cloud_physics  .AND.  icloud_scheme == 0 ) THEN
+                   nrswst = 0.0
+                   qrswst = 0.0
+                ENDIF
+             ENDIF
 
              IF ( ocean )  THEN
@@ -877,4 +972,12 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              IF ( .NOT. constant_waterflux )  qsws   = 0.0
+             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+                IF ( .NOT. constant_waterflux_qr )  THEN
+                   qrsws = 0.0
+                ENDIF
+                IF ( .NOT. constant_waterflux_nr )  THEN
+                   nrsws = 0.0
+                ENDIF
+             ENDIF
           ENDIF
 
@@ -925,4 +1028,11 @@
             q_surface_initial_change /= 0.0 )  THEN
           q(nzb,:,:) = q(nzb,:,:) + q_surface_initial_change
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             IF ( qr_surface_initial_change /= 0.0 )  THEN
+                qr(nzb,:,:) = qr(nzb,:,:) + qr_surface_initial_change
+             ELSEIF ( nr_surface_initial_change /= 0.0 ) THEN
+                nr(nzb,:,:) = nr(nzb,:,:) + nr_surface_initial_change
+             ENDIF
+          ENDIF
        ENDIF
 
@@ -939,4 +1049,10 @@
           tq_m = 0.0
           q_p = q
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             tqr_m = 0.0
+             qr_p = qr
+             tnr_m = 0.0
+             nr_p = nr
+          ENDIF
        ENDIF
 
@@ -1109,5 +1225,11 @@
 !--    including ghost points)
        e_p = e; pt_p = pt; u_p = u; v_p = v; w_p = w
-       IF ( humidity  .OR.  passive_scalar )  q_p = q
+       IF ( humidity  .OR.  passive_scalar )  THEN
+          q_p = q
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             qr_p = qr
+             nr_p = nr
+          ENDIF
+       ENDIF
        IF ( ocean )  sa_p = sa
 
@@ -1117,5 +1239,11 @@
 !--    there before they are set. 
        te_m = 0.0; tpt_m = 0.0; tu_m = 0.0; tv_m = 0.0; tw_m = 0.0
-       IF ( humidity  .OR.  passive_scalar )  tq_m = 0.0
+       IF ( humidity  .OR.  passive_scalar )  THEN
+          tq_m = 0.0
+          IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+             tqr_m = 0.0
+             tnr_m = 0.0
+          ENDIF
+       ENDIF
        IF ( ocean )  tsa_m = 0.0
 
Index: palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1047)
+++ palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1053)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! calculation of the maximum timestep according to the terminal velocity of rain 
+! drops in the two moment cloud scheme
+!
+! calculation of frequently used constants (pirho_l, dpirho_l, schmidt_p_1d3, 
+! hyrho) 
 !
 ! Former revisions:
@@ -66,5 +70,6 @@
     REAL    ::  t_surface
 
-    ALLOCATE( hyp(nzb:nzt+1), pt_d_t(nzb:nzt+1), t_d_pt(nzb:nzt+1) )
+    ALLOCATE( hyp(nzb:nzt+1), pt_d_t(nzb:nzt+1), t_d_pt(nzb:nzt+1),  &
+              hyrho(nzb:nzt+1) )
 
 !
@@ -73,4 +78,14 @@
     l_d_r  = l_v / r_d
     l_d_rv = l_v / r_v
+
+    schmidt_p_1d3 = schmidt**( 1.0 / 3.0 )
+
+    pirho_l  = pi * rho_l / 6.0
+    dpirho_l = 1.0 / pirho_l 
+!
+!-- Calculate timestep according to precipitation
+    IF ( icloud_scheme == 0  .AND.  precipitation )  THEN
+       dt_precipitation = MINVAL( dzu(nzb+2:nzt) ) / w_precipitation
+    ENDIF
 !
 !-- Calculate factor used in equation for droplet growth by condensation
@@ -94,5 +109,6 @@
                    ( (t_surface - g/cp * zu(k)) / t_surface )**(1.0/0.286)
        pt_d_t(k) = ( 100000.0 / hyp(k) )**0.286
-       t_d_pt(k) = 1.0 / pt_d_t(k)       
+       t_d_pt(k) = 1.0 / pt_d_t(k)
+       hyrho(k)  = hyp(k) / ( r_d * t_d_pt(k) * pt_init(k) )       
     ENDDO
 
